> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/network/fetchcallreadonlyfunction.md).

# fetchCallReadOnlyFunction

Calls a read-only function on a deployed smart contract. The function is executed by the node without creating a transaction on-chain.

***

### Usage

```ts
import { fetchCallReadOnlyFunction, Cl } from '@stacks/transactions';

const result = await fetchCallReadOnlyFunction({
  contractAddress: 'ST1PQHQKV0RJXZFY1DGX8MNSNYVE3VGZJSRTPGZGM',
  contractName: 'my-contract',
  functionName: 'get-balance',
  functionArgs: [Cl.standardPrincipal('ST1SJ3DTE5DN7X54YDH5D64R3BCB6A2AG2ZQ8YPD5')],
  senderAddress: 'ST1SJ3DTE5DN7X54YDH5D64R3BCB6A2AG2ZQ8YPD5',
  network: 'testnet',
});

console.log(result); // ClarityValue — e.g. UIntCV { type: 'uint', value: 1000n }
```

#### Notes

* The function does **not** need to be defined as `read-only` in the contract — any public function can be called this way (without side effects).
* The `senderAddress` is the simulated sender for the read-only call.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/fetch.ts#L296)

***

### Signature

```ts
function fetchCallReadOnlyFunction(opts: {
  contractName: string;
  contractAddress: string;
  functionName: string;
  functionArgs: ClarityValue[];
  senderAddress: string;
} & NetworkClientParam): Promise<ClarityValue>;
```

***

### Returns

`Promise<ClarityValue>`

A promise that resolves to the Clarity value returned by the function.

***

### Parameters

#### opts.contractAddress (required)

* **Type**: `string`

The Stacks address of the contract deployer.

#### opts.contractName (required)

* **Type**: `string`

The name of the contract.

#### opts.functionName (required)

* **Type**: `string`

The name of the function to call.

#### opts.functionArgs (required)

* **Type**: `ClarityValue[]`

An array of Clarity values to pass as arguments. Use the `Cl` namespace helpers to construct them.

#### opts.senderAddress (required)

* **Type**: `string`

The address of the simulated sender.

#### opts.network (optional)

* **Type**: `StacksNetworkName | StacksNetwork`

The network to query. Defaults to `'mainnet'`.

#### opts.client (optional)

* **Type**: `NetworkClient`

Custom client configuration for the API call.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/network/fetchcallreadonlyfunction.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
